function K2BExtendedComboCollection() {
  this.control = null;
  this.Values = null;
  this.selectedValues = null;

  this.SetSelectedValues = function (selectedValues) {
    if (this.control != null) this.control.value = selectedValues;
    this.selectedValues = selectedValues;
  };

  this.GetSelectedValues = function () {
    return this.selectedValues;
  };

  this.SetValues = function (v) {
    this.Values = v;
    if (this.control != null) this.control.values = this.Values;
  };

  // In collection controls, the SetValue method sets the value as selected without modifying
  this.SetValue = function (v) {
    if (this.selectedValues.filter(value => v.toString().trim() === value.toString().trim()).length === 0) this.selectedValues.push(v);
    if (this.control != null) this.control.value = this.selectedValues;

    this.onfocus();
    this.oninput();
    this.onchange();

    if (uc.ControlValueChanged) {
      uc.ControlValueChanged();
    }
  };

  this.show = function () {
    var uc = this;
    if (this.control == null) {
      // Only create control once
      this.control = document.createElement('k2bt-enhancedcombo');
      this.control.maxSelectionSize = 0;

      this.control.values = this.Values;
      this.control.value = this.selectedValues;

      this.control.addEventListener('change', function () {
        uc.SetSelectedValues(uc.control.value);

        if (uc.ControlValueChanged) {
          uc.ControlValueChanged();
        }
      });

      this.control.addEventListener('newRecordClicked', function () {
        if (uc.CreateItem) {
          uc.CreateItem();
        }
      });

      this.control.addEventListener('input', function () {
        uc.SetSelectedValues(uc.control.value);
      });

      var container = document.getElementById(this.ContainerName);
      container.appendChild(this.control);
    }

    this.control.includesearch = this.IncludeSearch;
    this.control.enableadditem = this.EnableAddItem;
    this.control.enableclearselectionaction = this.EnableClearSelectionAction;
    this.control.includeemptyitem = this.IncludeEmptyItem;
    this.control.enabled = this.Enabled;
    this.control.showselectionastags = this.ShowSelectionAsTags;
    this.control.displayaslist = this.DisplayAsList;
    this.control.headermaxvisibleitems = this.HeaderMaxVisibleItems;
    this.control.readonlyclass = this.Class.split(' ')
      .map(s => 'Readonly' + s)
      .join(' ');

    this.control.emptyitemtext = k2btools.getTranslatedMessage(k2btools.resolveValue(this.EmptyItemText, 'GX_EmptyItemText'));
    this.control.noresultsfoundtext = k2btools.getTranslatedMessage(k2btools.resolveValue(this.NoResultsFoundText, 'K2BT_NoItems'));
    this.control.searchfieldplaceholder = k2btools.getTranslatedMessage(k2btools.resolveValue(this.SearchFieldPlaceholder, 'K2BT_Search'));
    this.control.additemcaption = k2btools.getTranslatedMessage(k2btools.resolveValue(this.AddItemCaption, 'K2BT_EnhancedComboAddItemCaption'));
    this.control.clearselectioncaption = k2btools.getTranslatedMessage(k2btools.resolveValue(this.ClearSelectionCaption, 'K2BT_ClearMultipleFilterSelection'));
  };
}
