var k2btools = k2btools || {
  // Default value, if many instances are present then this properties will be set to false if any of the instances says so.
  updateCheckboxes: true,
  showMessagesAssociatedWithAttributes: true,

  checkboxSelector: 'input[type="checkbox"]:not(.bootstrap-switch *)',

  messagesShown: [], // Used to avoid duplicating messages

  ParentsCheck: function (element, hops) {
    i = 0;
    while (i < hops && element != document.documentElement && element.parentElement != null) {
      element = element.parentElement;
      i++;
    }
    return element.parentElement != null || element == document.documentElement;
  },

  checkboxRefresh: function () {
    if (this.updateCheckboxes) {
      $(this.checkboxSelector).each(function (i, el) {
        if ($(el).next('label').length == 0) {
          label = $("<label data-gx-sr-only='' />");
          label.attr('for', $(el).attr('id'));
          $(el).after(label);

          $(el).parent('label').addClass('K2BT_CheckboxContainer');
        }
      });
    }
  },

  RefreshTooltips: function () {
    $(".tooltip[role='tooltip']").remove();
    $('.Image_Action, .K2BImage_ContextHelp, .K2BContextHelp, .K2BT_EntityManagerSocialAction').each(function (i, element) {
      var $element = $(element);
      $element.tooltip({ delay: { show: 500, hide: 500 }, container: $element.parent(), trigger: 'hover' });
    });

    $('.Image_Action, .K2BImage_ContextHelp, .K2BContextHelp').on('click', function () {
      $(this).tooltip('hide');
    });

    $(".Image_Action[title!=''], .K2BImage_ContextHelp[title!=''], .K2BContextHelp[title!='']").each(function (i, element) {
      var $element = $(element);
      $element.tooltip('hide').attr('data-original-title', $element.attr('title')).tooltip('fixTitle');
      $element.attr('title', '');
    });

    var element = $(".K2BT_EntityManagerSocialAction[title!=''][title!=data-original-title]");
    $(element).attr('data-original-title', element.attr('title')).tooltip('fixTitle').tooltip('show');
  },

  RefreshGridLastColumnTag: function () {
    $('.gx-grid .Grid_WorkWith').each(function (i, grid) {
      $(grid).find('th, td').removeClass('K2BToolsLastVisibleColumn').removeClass('K2BToolsFirstVisibleColumn');
      var lastColumnHeader = k2btools
        .$(grid)
        .find('tr th')
        .filter(function (index, el) {
          return $(el).css('display') != 'none';
        })
        .last();
      lastColumnHeader.addClass('K2BToolsLastVisibleColumn');

      var firstColumnHeader = k2btools
        .$(grid)
        .find('tr th')
        .filter(function (index, el) {
          return $(el).css('display') != 'none';
        })
        .first();
      firstColumnHeader.addClass('K2BToolsFirstVisibleColumn');

      var colIndex = lastColumnHeader.attr('data-colindex');
      k2btools
        .$(grid)
        .find("td[data-colindex='" + colIndex + "']")
        .addClass('K2BToolsLastVisibleColumn');
    });
  },

  afterEventObserver: function () {
    this.checkboxRefresh();
    this.RefreshTooltips();
    this.RefreshGridLastColumnTag();
  },

  resolveValue: function (provided, defaultValue) {
    return provided === undefined || provided === '' || provided == null ? defaultValue : provided;
  },

  getTranslatedMessage: function (msg) {
    if (msg.indexOf('GX') === 0 || msg.indexOf('K2B') === 0) {
      var translated = gx.msg[msg];
      if (translated !== undefined) {
        return translated;
      }
    }
    return msg;
  },

  updateFormControlVisibility: function (container, visible) {
    if (container.parentElement.parentElement.classList.contains('gx-form-group')) {
      if (!visible) {
        container.parentElement.parentElement.style.display = 'none';
      } else {
        container.parentElement.parentElement.style.display = null;
      }
    }
  },
};

(function (doc) {
  var scriptElm = doc.scripts[doc.scripts.length - 1];

  var parts = scriptElm.src.split('/');
  parts.pop();
  parts.push('K2BToolsComponents');
  parts.push('dist');
  parts.push('k2btools-components');
  var url = parts.join('/');

  var esmBuild = doc.createElement('script');

  esmBuild.src = url + '/k2btools-components.esm.js';
  esmBuild.setAttribute('data-stencil-namespace', 'k2btools-components');

  var nonEsmBuild = doc.createElement('script');
  nonEsmBuild.src = url + '/k2btools-components.js';
  nonEsmBuild.setAttribute('data-stencil-namespace', 'k2btools-components');

  esmBuild.setAttribute('type', 'module');
  nonEsmBuild.setAttribute('nomodule', '');

  doc.head.appendChild(esmBuild);
  doc.head.appendChild(nonEsmBuild);
})(document);
